<?php
/**
 * Plugin Name: Welcome!
 * Plugin URI: http://mandelbaum.ro/blog/welcome-plugin/
 * Description: The plugin allows the user to display a full page welcome message to its visitors.
 * Version: 1.2
 * Author: Dragos Flusca
 * Author URI: http://mandelbaum.ro/
 * License: GPL2
 */
$version = '1.2';
$wDefaults = array();
$wVar = array();
$wDefaults['welcome_color'] = '#1d88c6'; //hex
$wDefaults['welcome_sec_after'] = '3'; //seconds
$wDefaults['welcome_sec_fade_out'] = '2'; //seconds
$wDefaults['welcome_content'] = '<p style="text-align: center;"><span style="font-size: 18pt; font-family: trebuchet ms,geneva; color: #ffffff;">Put some text here...</span></p>'; //html allowed
$wDefaults['welcome_cookie_duration'] = '30';  //days

$wDefaults['welcome_cookie_name'] = 'wpwelcomeplugin'; 


function welcome_getOptions(){
global $wDefaults; 

	$wVar = array();
	$wVar['welcome_color'] = get_option( 'welcome_color', $wDefaults['welcome_color'] );
	$wVar['welcome_sec_after'] = (int)get_option( 'welcome_sec_after', $wDefaults['welcome_sec_after'] );
	$wVar['welcome_sec_fade_out'] = (int)get_option( 'welcome_sec_fade_out', $wDefaults['welcome_sec_fade_out'] );
	$wVar['welcome_content'] = stripslashes(get_option( 'welcome_content', $wDefaults['welcome_content'] ));
	$wVar['welcome_cookie_duration'] = (int)get_option( 'welcome_cookie_duration', $wDefaults['welcome_cookie_duration'] );
	return $wVar;
}

function welcome_output (){
	global $wDefaults;
	$wVar = welcome_getOptions();
	
	if($_COOKIE[$wDefaults['welcome_cookie_name']] == '1') return;
	
	echo '<div id="cover" style="background-color: ' .$wVar['welcome_color']. ';height:100%;width:100%; position:fixed;z-index:2147483646; top: 0; margin: 0 auto; left:0;">' . $wVar['welcome_content'] . '</div><noscript><style>#cover{ display: none; visibility: hidden; height: 0px; width: 0px; }</style></noscript>';
	
	/* JS generation, mess */
	echo '<script> 
	jQuery(document).ready(function($){';
	if($wVar['welcome_cookie_duration'] > 0) 
		echo 'if(jQuery.cookie("'.$wDefaults['welcome_cookie_name'].'")=="1") return;';
	echo 'setTimeout(function() { jQuery("#cover").fadeOut('. ($wVar['welcome_sec_fade_out'] * 1000) .'); }, '. ($wVar['welcome_sec_after'] * 1000) .');
	
			jQuery.cookie("'.$wDefaults['welcome_cookie_name'] .'", "1", { expires: '. $wVar['welcome_cookie_duration']  .' });
	}); </script>';
	
	wp_enqueue_script('jquery');
	wp_enqueue_script( 'jquery-cookie', plugins_url('/jquery.cookie.js', __FILE__ ), array( 'jquery' ), '1.4.1', false );
}

function welcome_updateOptions($values){
	if( $values ) {
		// Read their posted value
		$wPost = array();
		$wPost['welcome_color'] = trim($values[ 'welcome_color' ]);
		$wPost['welcome_sec_after'] = (int) trim($values[ 'welcome_sec_after' ]);
		$wPost['welcome_sec_fade_out'] = (int)  trim($values[ 'welcome_sec_fade_out' ]);
		$wPost['welcome_content'] = trim(stripslashes($values[ 'welcome_content' ]));
		$wPost['welcome_cookie_duration'] = (int) trim($values[ 'welcome_cookie_duration' ]);
					
		// Save the posted value in the database
		if(!empty($wPost['welcome_color'])) update_option( 'welcome_color', $wPost['welcome_color']);
		if(!empty($wPost['welcome_sec_after'])) update_option( 'welcome_sec_after', $wPost['welcome_sec_after']);
		if(!empty($wPost['welcome_sec_fade_out'])) update_option( 'welcome_sec_fade_out', $wPost['welcome_sec_fade_out']);
		if(!empty($wPost['welcome_content'])) update_option( 'welcome_content', $wPost['welcome_content']);
		if(!empty($wPost['welcome_cookie_duration'])) update_option( 'welcome_cookie_duration', $wPost['welcome_cookie_duration']);
	} 
}

function welcome_plugin_page() {
	global $wDefaults;
	
	//update options values
	welcome_updateOptions($_POST);
	
	// Read in existing option value from database
	$wVar = welcome_getOptions();
	?>
		
<h2>Welcome!</h2>

<div class="postbox" style="margin: 15px; padding: 10px; text-align:center; line-height: 1.4em;">
		<form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_top">
			If you enjoy using our free plugin, <a href="http://wordpress.org/plugins/welcome/">give it a 5 star rating</a> or consider a small contribution for further development.  <br />
			<input type="hidden" name="cmd" value="_s-xclick">
			<input type="hidden" name="hosted_button_id" value="YBZLTN49L9MVQ">
			<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!" style="margin-top: 10px;">
		</form>
	</div>
<?php  
// Put an options updated message on the screen
if( $_POST ) {
	echo '<div class="updated"><p><strong>Options saved.</strong></p></div>';  
}

/*--------------------------------------------------------------- ADMIN FORM -----------------------------------------------------------------------------------*/
?>
<form name="form1" method="post">
<table class="form-table">
<tbody>
	<tr>
		<th>
			<label for="welcome_color">Background color:</label>
		</th>
		<td>
			<input type="text" id="welcome_color" name="welcome_color" value="<?php echo $wVar['welcome_color']; ?>" size="20" data-default-color="<?php echo $wDefaults['welcome_color']; ?>">
		</td>
	</tr>
	<tr>
		<th>
			<label for="welcome_sec_after">Display duration: </label>
		</th>
		<td>
			<input type="text" name="welcome_sec_after" value="<?php echo $wVar['welcome_sec_after']; ?>" size="3"> seconds. <br /> <i>Minimum 2 seconds recommended.</i>
		</td>
	</tr>
	<tr>
		<th>
			<label for="welcome_sec_fade_out">Fadeout length: </label>
		</th>
		<td>
			<input type="text" name="welcome_sec_fade_out" value="<?php echo $wVar['welcome_sec_fade_out']; ?>" size="3"> seconds.<br /> <i>Set 0 to close the message instantly (after "display duration").</i>
		</td>
	</tr>
	<tr>
		<th>
			<label for="welcome_sec_fade_out">Cookie expires after: </label> 
		</th>
		<td>
			<input type="text" name="welcome_cookie_duration" value="<?php echo $wVar['welcome_cookie_duration']; ?>" size="3"> days.<br /><i>Hides the welcome message from visitors <br /> who already saw it in the past X days.</i>
		</td>
	</tr>
</tbody>
</table>
<h3> Content: </h3>
<p><i>Use the form below to type and customize your welcome message.</i></p>
<div style="margin-right:5%;">
	<?php wp_editor( $wVar['welcome_content'], 'welcome_content', array('drag_drop_upload' => true, 'textarea_rows' => 10) ); ?>
<div>
<p class="submit">
	<input type="submit" class="button button-primary" name="Submit" value="Update Options" />
</p>

</form>
<script type="text/javascript">
function tinyMCEbackgroundCopy(){
	var tm = tinymce.activeEditor.dom;
	console.log( jQuery('#welcome_color').val() );
	if(tm) tm.setStyle(tm.select('body'), 'background-color', jQuery('.form-table .wp-picker-container .wp-color-result').css('background-color') );
}

jQuery(document).ready(function($){	
	$('#welcome_color').wpColorPicker({hide: false, change: function(event, ui){ 
		setTimeout(function(){tinyMCEbackgroundCopy()}, 300);
	}});
});
</script>
<?php  
/*--------------------------------------------------------------- END ADMIN FORM -----------------------------------------------------------------------------------*/
}

function welcome_change_mce_options( $init ) {
global $wDefaults;
  $wc = get_option('welcome_color');
  if(empty($wc)) $wc = $wDefaults['welcome_color'];
  $init['setup'] = 'function(editor) { setTimeout(function(){editor.getBody().style.backgroundColor = "'. $wc .'";}, 300); } ';
  $init['width'] = '100%';
 return $init;
}
function welcome_enable_more_buttons($buttons) {
  $buttons[] = 'hr';
  $buttons[] = 'sub';
  $buttons[] = 'sup';
  $buttons[] = 'fontselect';
  $buttons[] = 'fontsizeselect';
  $buttons[] = 'cleanup';
  $buttons[] = 'styleselect';
 
  return $buttons;
}
function welcome_ses_tinymce_css($wp) {
	$wp .= ','  . plugins_url().'/welcome/editor.css?1';
	return $wp;
}
function welcome_color_picker( $hook_suffix ) {
    wp_enqueue_style( 'wp-color-picker' );
    wp_enqueue_script( 'wp-color-picker' );
}
function welcome_menu (){
	add_options_page('<i>Welcome</i> plugin', 'Welcome!', 9, 'welcome_plugin', 'welcome_plugin_page');
}
function welcome_activate() {
global $wDefaults, $version;
	$oldVersion = get_option('welcome_plugin_version');
	if(empty($oldVersion)) welcome_updateOptions($wDefaults);
	update_option( 'welcome_plugin_version', $version);	
}

if($_GET['page'] == 'welcome_plugin'){
	add_filter( 'mce_css', 'welcome_ses_tinymce_css' );
	add_filter('tiny_mce_before_init', 'welcome_change_mce_options');
	add_action( 'admin_enqueue_scripts', 'welcome_color_picker' );
	add_filter("mce_buttons_3", "welcome_enable_more_buttons");
}
add_action('admin_menu', 'welcome_menu');
add_action('wp_footer', 'welcome_output');
register_activation_hook( __FILE__, 'welcome_activate' );
?>
